Product SiteDocumentation Site

6.2. Các lệnh aptitude, apt-get, và apt

APT is a vast project, whose original plans included a graphical interface. It is based on a library which contains the core application, and apt-get is the first front end — command-line based — which was developed within the project. apt is a second command-line based front end provided by APT which overcomes some design mistakes of apt-get.
Both tools are built on top of the same library and are thus very close, but the default behavior of apt has been improved for interactive use and to actually do what most users expect. The APT developers reserve the right to change the public interface of this tool to further improve it. On the opposite, the public interface of apt-get is well defined and will not change in any backwards incompatible way. It is thus the tool that you want to use when you need to script package installation requests.
Numerous other graphical interfaces then appeared as external projects: synaptic, aptitude (which includes both a text mode interface and a graphical one — even if not complete yet), wajig, etc. The most recommended interface, apt, is the one that we will use in the examples given in this section. Note, however, that apt-get and aptitude have a very similar command line syntax. When there are major differences between these three commands, these will be detailed.

6.2.1. Khởi tạo

For any work with APT, the list of available packages needs to be updated; this can be done simply through apt update. Depending on the speed of your connection and configuration, the operation can take a while, since it involves downloading a certain number of (usually compressed) files (Packages, Sources, Translation-language-code), which have gradually become bigger and bigger as Debian has developed (at least 10 MB of data for the main section). Of course, installing from a CD-ROM/DVD set does not require any downloading — in this case, the operation is very fast.

6.2.2. Cài đặt và Gỡ bỏ

With APT, packages can be added or removed from the system, respectively with apt install package and apt remove package. In both cases, APT will automatically install the necessary dependencies or delete the packages which depend on the package that is being removed. The apt purge package command involves a complete uninstallation by deleting the configuration files as well.
If the file sources.list mentions several distributions, it is possible to give the version of the package to install. A specific version number can be requested with apt install package=version, but indicating its distribution of origin (Stable, Testing or Unstable) — with apt install package/distribution — is usually preferred. With this command, it is possible to go back to an older version of a package (if, for instance, you know that it works well), provided that it is still available in one of the sources referenced by the sources.list file. Otherwise the snapshot.debian.org archive can come to the rescue (see sidebar TIẾN THÊM MỘT BƯỚC Các gói cũ: snapshot.debian.org).

Ví dụ 6.4. Installation of the Unstable version of spamassassin

# apt install spamassassin/unstable
If the package to install has been made available to you under the form of a simple .deb file without any associated package repository, it is still possible to use APT to install it together with its dependencies (provided that the dependencies are available in the configured repositories) with a simple command: apt install ./path-to-the-package.deb. The leading ./ is important to make it clear that we are referring to a filename and not to the name of a package available in one of the repositories.

6.2.3. Nâng cấp hệ thống

Chúng tôi khuyên bạn nên nâng cấp đều đặn, bởi vì chúng bao gồm các cập nhật bảo mật mới nhất. Để nâng cấp, sử dụng apt upgrade, apt-get upgrade hoặc aptitude safe-upgrade (tất nhiên sau khi apt update). Lệnh này sẽ tìm các gói được cài đặt và có thể được nâng cấp mà không cần phải gỡ bỏ bất kỳ gói nào. Nói cách khác, mục tiêu là đảm bảo nâng cấp ít nhất phòng chống xâm nhập. apt-get hơi đòi hỏi nhiều hơn aptitude hoặc apt bởi vì nó sẽ từ chối cài đặt các gói không được cài đặt trước.
apt thường sẽ chọn số phiên bản gần đây nhất (ngoại trừ các gói từ Experimentalstable-backports, mặc định mặc định là số phiên bản của chúng). Nếu bạn đã chỉ định Testing hoặc Unstable trong sources.list của mình, apt upgrade sẽ chuyển hầu hết hệ thống Stable của bạn sang Testing hoặc Unstable, điều này có thể không phải là điều bạn mong muốn.
To tell apt to use a specific distribution when searching for upgraded packages, you need to use the -t or --target-release option, followed by the name of the distribution you want (for example, apt -t stable upgrade). To avoid specifying this option every time you use apt, you can add APT::Default-Release "stable"; in the file /etc/apt/apt.conf.d/local.
Đối với nâng cấp quan trọng hơn, chẳng hạn như sự thay đổi từ một phiên bản Debian lớn sang phiên bản tiếp theo, bạn cần phải sử dụng apt full-upgrade. Với chỉ dẫn này, apt sẽ hoàn tất quá trình nâng cấp ngay cả khi nó đã gỡ bỏ một số gói đã lỗi thời hoặc cài đặt các phụ thuộc mới. Đây cũng là lệnh được sử dụng bởi những người dùng làm việc hàng ngày với bản phát hành Unstable của Debian và theo dõi sự phát triển của từng ngày. Nó đơn giản đến nỗi hầu như không cần giải thích: danh tiếng của APT dựa trên tính năng tuyệt vời này.
Không giống như aptaptitude, apt-get không biết lệnh full-upgrade. Thay vào đó, bạn nên sử dụng apt-get dist-upgrade, câu lệnh mạnh mẽ và tuyệt vời mà aptaptitude cũng chấp nhận để tạo sự tiện lợi của người dùng quen với nó.
The results of these operations are logged into /var/log/apt/history.log and /var/log/apt/term.log, whereas dpkg keeps its log in a file called /var/log/dpkg.log.

6.2.4. Tùy chọn Cấu hình

Besides the configuration elements already mentioned, it is possible to configure certain aspects of APT by adding directives in a file of the /etc/apt/apt.conf.d/ directory or /etc/apt/apt.conf itself. Remember, for instance, that it is possible for APT to tell dpkg to ignore file conflict errors by specifying DPkg::options { "--force-overwrite"; }.
Nếu Web chỉ có thể được truy cập thông qua proxy, hãy thêm một dòng như Acquire::http::proxy "http://yourproxy:3128". Đối với một FTP proxy, hãy viết Acquire::ftp::proxy "ftp://yourproxy". Để khám phá thêm các tùy chọn cấu hình, hãy đọc trang hướng dẫn sử dụng apt.conf(5) trang thông tin của câu lệnh với câu lệnh man apt.conf (để biết chi tiết về các trang một cách thủ công, xem Phần 7.1.1, “Manual Pages”).

6.2.5. Các ưu tiên Quản lý Gói

Một trong những khía cạnh quan trọng nhất trong cấu hình của APT là quản lý các ưu tiên liên quan đến từng nguồn gói. Ví dụ: bạn có thể muốn mở rộng một bản phân phối với một hoặc hai gói mới hơn từ Testing, Unstable hoặc Experimental. Có thể gán một mức độ ưu tiên cho mỗi gói có sẵn (cùng một gói có thể có một số ưu tiên tùy thuộc vào phiên bản của nó hoặc bản phân phối cung cấp nó). Những ưu tiên này sẽ ảnh hưởng đến hành vi của APT: cho mỗi gói, nó sẽ luôn chọn phiên bản có mức độ ưu tiên cao nhất (trừ khi phiên bản này cũ hơn phiên bản đã cài đặt và nếu mức độ ưu tiên của nó nhỏ hơn 1000).
APT định nghĩa một số ưu tiên mặc định. Mỗi phiên bản gói được cài đặt có mức ưu tiên là 100. Phiên bản không được cài đặt mặc định có mức ưu tiên là 500, nhưng có thể lên tới 990 nếu nó là một phần của bản phát hành đích (được định nghĩa bằng tùy chọn dòng lệnh -t hoặc APT :: Default-Release chỉ thị cấu hình).
You can modify the priorities by adding entries in a file in /etc/apt/preferences.d/ or the /etc/apt/preferences file with the names of the affected packages, their version, their origin and their new priority.
APT will never install an older version of a package (that is, a package whose version number is lower than the one of the currently installed package) except if its priority is higher than 1000 (or it is explicitely requested by the user, see Phần 6.2.2, “Cài đặt và Gỡ bỏ”). APT will always install the highest priority package which follows this constraint. If two packages have the same priority, APT installs the newest one (whose version number is the highest). If two packages of same version have the same priority but differ in their content, APT installs the version that is not installed (this rule has been created to cover the case of a package update without the increment of the revision number, which is usually required).
In more concrete terms, a package whose priority is
< 0
will never be installed,
1..99
will only be installed if no other version of the package is already installed,
100..499
will only be installed if there is no other newer version installed or available in another distribution,
500....989
will only be installed if there is no newer version installed or available in the target distribution,
990..1000
will be installed except if the installed version is newer,
> 1000
will always be installed, even if it forces APT to downgrade to an older version.
When APT checks /etc/apt/preferences and /etc/apt/preferences.d/, it first takes into account the most specific entries (often those specifying the concerned package), then the more generic ones (including, for example, all the packages of a distribution). If several generic entries exist, the first match is used. The available selection criteria include the package's name and the source providing it. Every package source is identified by the information contained in a Release file that APT downloads together with the Packages files. It specifies the origin (usually “Debian” for the packages of official mirrors, but it can also be a person's or an organization's name for third-party repositories). It also gives the name of the distribution (usually Stable, Testing, Unstable or Experimental for the standard distributions provided by Debian) together with its version (for example, 10 for Debian Buster). Let's have a look at its syntax through some realistic case studies of this mechanism.
Giả sử rằng bạn chỉ muốn sử dụng các gói từ phiên bản ổn định của Debian. Không được cài đặt những phiên bản được cung cấp trong các phiên bản khác ngoại trừ yêu cầu rõ ràng. Bạn có thể viết các mục sau trong file /etc/apt /preferences:
Package: *
Pin: release a=stable
Pin-Priority: 900

Package: *
Pin: release o=Debian
Pin-Priority: -10
a=stable xác định tên của bản phân phối đã chọn. o=Debian giới hạn phạm vi cho các gói có nguồn gốc là “Debian“.
Let's now assume that you have a server with several local programs depending on the version 5.24 of Perl and that you want to ensure that upgrades will not install another version of it. You could use this entry:
Package: perl
Pin: version 5.24*
Pin-Priority: 1001
To gain a better understanding of the mechanisms of priority and distribution or repository properties to pin do not hesitate to execute apt-cache policy to display the default priority associated with each package source, or apt-cache policy package to display the default priority for each available version and source of a package as explained in MẸO apt-cache policy.
The reference documentation for the files /etc/apt/preferences and /etc/apt/preferences.d/ is available in the manual page apt_preferences(5), which you can display with man apt_preferences.

6.2.6. Làm việc với một số bản phân phối

apt là một công cụ tuyệt vời, việc chọn các gói đến từ các bản phân phối khác khá hấp dẫn. Ví dụ: sau khi đã cài đặt một hệ thống Stable, bạn có thể thử một gói phần mềm có sẵn trong Testing hoặc Unstable mà không bị phân tán quá nhiều từ trạng thái ban đầu của hệ thống.
Thậm chí nếu bạn đôi khi gặp phải các vấn đề trong khi trộn các gói từ các phân phối khác nhau, thì apt sẽ quản lý sự tồn tại song song này rất tốt và hạn chế rủi ro rất hiệu quả. Cách tốt nhất để tiến hành là liệt kê tất cả các bản phân phối được sử dụng trong /etc/apt/sources.list (một số người luôn đặt ba bản phân phối nhưng hãy nhớ rằng Unstable dành cho những người dùng có kinh nghiệm) và để xác định phân phối tham chiếu của bạn với APT::Default-Release (xem Phần 6.2.3, “Nâng cấp hệ thống”).
Hãy giả sử Stable là bản phân phối tham khảo của bạn nhưng TestingUnstable cũng được liệt kê trong tệp sources.list của bạn. Trong trường hợp này, bạn có thể sử dụng apt installpackage/testing để cài đặt một gói từ Testing. Nếu cài đặt không thành công do một số gói phụ thuộc không đáng tin cậy, hãy giải quyết các gói phụ thuộc trong Testing bằng cách thêm tham số -t testing . Điều tương tự cũng áp dụng cho Unstable.
Trong trường hợp này, nâng cấp (upgradefull-upgrade) được thực hiện trong Stable ngoại trừ các gói đã được nâng cấp lên phân phối khác: các gói này sẽ theo các cập nhật có sẵn trong các bản phân phối khác. Chúng ta sẽ giải thích hành vi này với sự trợ giúp của các ưu tiên mặc định được thiết lập bởi APT dưới đây. Đừng ngần ngại sử dụng apt-cache policy (xem bên bar MẸO apt-cache policy) để xác minh các ưu tiên đã cho.
Tất cả mọi thứ tập trung vào thực tế rằng APT chỉ xem xét các gói có phiên bản cao hơn hoặc bằng với phiên bản đã cài đặt (giả sử rằng /etc/apt/preferenceskhông được sử dụng để ép buộc các ưu tiên cao hơn 1000 đối với một số gói).
Giả sử bạn đã cài đặt phiên bản 1 của gói đầu tiên từ Stable và phiên bản 2 và 3 có sẵn tương ứng trong TestingUnstable. Phiên bản đã cài đặt có mức ưu tiên 100 nhưng phiên bản có sẵn trong Stable (giống hệt nhau) có mức độ ưu tiên là 990 (vì đây là một phần của bản phát hành mục tiêu). Gói trong TestingUnstable có mức ưu tiên là 500 (mức độ ưu tiên mặc định của một phiên bản không được cài đặt). Gói được chọn là phiên bản 1 với mức ưu tiên là 990. Gói “lưu lại ở trong Stable“.
Let's take the example of another package whose version 2 has been installed from Testing. Version 1 is available in Stable and version 3 in Unstable. Version 1 (of priority 990 — thus lower than 1000) is discarded because it is lower than the installed version. This only leaves version 2 and 3, both of priority 500. Faced with this alternative, APT selects the newest version, the one from Unstable. If you don't want a package installed from Testing to migrate to Unstable, you have to assign a priority lower than 500 (490 for example) to packages coming from Unstable. You can modify /etc/apt/preferences to this effect:
Package: *
Pin: release a=unstable
Pin-Priority: 490

6.2.7. Theo dõi gói cài đặt tự động

One of the essential functionalities of apt is the tracking of packages installed only through dependencies. These packages are called “automatic”, and often include libraries.
With this information, when packages are removed, the package managers can compute a list of automatic packages that are no longer needed (because there is no “manually installed” packages depending on them). apt-get autoremove or apt autoremove will get rid of those packages. aptitude does not have this command because it removes them automatically as soon as they are identified. In all cases, the tools display a clear message listing the affected packages.
Thói quen tốt là đánh dấu tự động bất kỳ gói nào mà bạn không cần trực tiếp để chúng được tự động loại bỏ khi không cần thiết nữa. apt-mark auto package sẽ đánh dấu gói cho sẵn như tự động trong khi apt-mark manual package làm ngược lại. aptitude markautoaptitude unmarkauto hoạt động theo cùng một cách mặc dù chúng có nhiều tính năng đánh dấu nhiều gói cùng một lúc (xem Phần 6.5.1, “aptitude). Giao diện tương tác dựa trên consolecủa aptitude cũng giúp bạn dễ dàng xem xét “cờ tự động“ trên nhiều gói.
Mọi người có thể muốn biết tại sao một gói cài đặt tự động được hiện diện trên hệ thống. Để nhận thông tin này từ dòng lệnh, bạn có thể sử dụng aptitude whypackage (aptapt-get không có tính năng tương tự):
$ aptitude why python-debian
i   aptitude         Suggests apt-xapian-index
p   apt-xapian-index Depends  python-debian (>= 0.1.14)